#ifndef _POISSON_H_
#define _POISSON_H_

const static float3 POISSON_DISC_3[3] = {
  float3(0.03629144, -0.6729883, 0.673966),
  float3(0.2604943, 0.3819185, 0.462298),
  float3(-0.8276176, 0.1310216, 0.837925),
};

const static float3 POISSON_DISC_4[4] = {
  float3(0.2499531, 0.05272384, 0.255453),
  float3(0.06602602, 0.8511158, 0.853673),
  float3(-0.8068371, 0.2031448, 0.832018),
  float3(0.1672733, -0.8983306, 0.913771),
};

const static float3 POISSON_DISC_5[5] = {
  float3(0.4265885, -0.02856767, 0.427544),
  float3(-0.4958617, 0.6284683, 0.800532),
  float3(0.1510115, -0.9672215, 0.978939),
  float3(-0.8823423, -0.06111487, 0.884456),
  float3(0.3594455, 0.8877649, 0.957772),
};

const static float3 POISSON_DISC_6[6] = {
  float3(0.2882068, -0.01743669, 0.288733),
  float3(0.4563387, 0.7316968, 0.862337),
  float3(-0.09932351, -0.6874095, 0.694548),
  float3(-0.8172536, -0.1486032, 0.830654),
  float3(-0.3173487, 0.6901151, 0.759585),
  float3(0.755228, -0.6025483, 0.966144),
};

const static float3 POISSON_DISC_7[7] = {
  float3(-0.6089213, -0.4501877, 0.757267),
  float3(-0.009813516, 0.7205817, 0.720648),
  float3(-0.6250216, 0.3557848, 0.719191),
  float3(0.1639658, -0.9733449, 0.987059),
  float3(0.1945637, -0.07419196, 0.208228),
  float3(0.6903412, 0.686608, 0.973654),
  float3(0.8199379, -0.5492654, 0.98691),
};

const static float3 POISSON_DISC_8[8] = {
  float3(0.2621835, -0.3737944, 0.456576),
  float3(0.3825936, 0.7843677, 0.872703),
  float3(0.0694405, 0.2158682, 0.226762),
  float3(-0.6482297, -0.7468458, 0.988929),
  float3(0.9965374, -0.06787632, 0.998846),
  float3(-0.02138271, -0.9651856, 0.965422),
  float3(-0.5949808, -0.07100058, 0.599202),
  float3(-0.2330166, 0.8361546, 0.868016),
};

const static float3 POISSON_DISC_9[9] = {
  float3(-0.2455975, 0.1795238, 0.304215),
  float3(0.09794152, 0.9697901, 0.974723),
  float3(0.4669009, 0.5488772, 0.720599),
  float3(-0.5923115, 0.6493688, 0.878927),
  float3(-0.2348988, -0.7766684, 0.811413),
  float3(-0.7029026, -0.2767551, 0.755424),
  float3(0.2811318, -0.2708086, 0.390349),
  float3(0.81071, -0.08119426, 0.814766),
  float3(0.5910187, -0.7459579, 0.951712),
};

const static float3 POISSON_DISC_10[10] = {
  float3(-0.5240702, -0.1198222, 0.537594),
  float3(-0.792887, -0.6034344, 0.996395),
  float3(-0.7450832, 0.5598896, 0.932001),
  float3(-0.1711887, -0.7104562, 0.73079),
  float3(0.1374613, 0.3460627, 0.372364),
  float3(0.1474894, -0.2107921, 0.257266),
  float3(0.6167677, -0.01504828, 0.616951),
  float3(0.7715268, 0.5824855, 0.966718),
  float3(0.5671329, -0.5550337, 0.793538),
  float3(-0.1103906, 0.8740562, 0.880999),
};

const static float3 POISSON_DISC_12[12] = {
  float3(-0.9591199f, 0.1733136f, 0.974653f),
  float3(-0.5053024f, 0.000892461f, 0.5053031f),
  float3(-0.8128008f, -0.5761509f, 0.9962906f),
  float3(-0.4312738f, 0.5451242f, 0.6950953f),
  float3(0.4205956f, 0.3459567f, 0.5445978f),
  float3(0.02919278f, 0.6620036f, 0.662647f),
  float3(-0.06260777f, -0.137161f, 0.1507743f),
  float3(0.5440797f, -0.4841087f, 0.7282746f),
  float3(0.8371772f, -0.03614882f, 0.8379573f),
  float3(-0.1249691f, -0.8297285f, 0.8390868f),
  float3(0.5160919f, 0.7894483f, 0.9431751f),
  float3(0.3549989f, -0.9328386f, 0.9981042f)
};

const static float3 POISSON_DISC_16[16] = {
  float3(0.8954767f, -0.1575644f, 0.9092332f),
  float3(0.4352259f, -0.4984821f, 0.6617447f),
  float3(0.7695779f, 0.3616731f, 0.850328f),
  float3(0.1323851f, 0.0497573f, 0.141427f),
  float3(0.2105618f, 0.9109722f, 0.9349902f),
  float3(0.2277734f, 0.4944786f, 0.544417f),
  float3(-0.380273f, 0.1147139f, 0.3971987f),
  float3(-0.1111894f, -0.2835931f, 0.3046114f),
  float3(-0.2282531f, 0.5713289f, 0.6152368f),
  float3(-0.5346423f, -0.2667225f, 0.5974808f),
  float3(-0.5894181f, -0.762647f, 0.9638693f),
  float3(-0.2105553f, -0.9640824f, 0.9868071f),
  float3(-0.6383594f, 0.4755866f, 0.7960436f),
  float3(-0.9285333f, 0.1501847f, 0.9406006f),
  float3(0.3938299f, -0.9144654f, 0.995665f),
  float3(-0.9361477f, -0.3214122f, 0.989787f)
};

const static float3 POISSON_DISC_24[24] = {
  float3(0.04937396f, 0.02976172f, 0.05765022f),
  float3(-0.2517526f, -0.1488713f, 0.2924757f),
  float3(0.08991148f, -0.3482215f, 0.3596419f),
  float3(-0.2874624f, 0.3059576f, 0.4198151f),
  float3(0.2427425f, 0.3638484f, 0.4373895f),
  float3(0.4653715f, -0.276858f, 0.5414988f),
  float3(-0.5950293f, 0.07174515f, 0.599339f),
  float3(0.5978429f, 0.1261958f, 0.6110168f),
  float3(-0.1569897f, 0.6188509f, 0.638453f),
  float3(-0.1061006f, -0.6564524f, 0.6649715f),
  float3(-0.6132807f, -0.3248489f, 0.6940029f),
  float3(0.3505149f, 0.671895f, 0.7578282f),
  float3(-0.6101021f, 0.6048418f, 0.8591031f),
  float3(0.5450442f, -0.6669612f, 0.8613422f),
  float3(-0.8746202f, -0.09585806f, 0.8798575f),
  float3(0.8157356f, -0.3300874f, 0.8799899f),
  float3(-0.4046993f, -0.8112252f, 0.9065692f),
  float3(0.8501958f, 0.3312514f, 0.9124475f),
  float3(0.07507778f, -0.9434683f, 0.9464508f),
  float3(0.9473069f, -0.005138647f, 0.9473209f),
  float3(-0.162317f, 0.9532719f, 0.9669923f),
  float3(0.6808234f, 0.6924866f, 0.9711118f),
  float3(-0.93586f, 0.3136373f, 0.9870169f),
  float3(-0.7859368f, -0.6157285f, 0.9984079f),
};

const static float3 POISSON_DISC_25[25] = {
  float3(-0.4697095f, -0.5649445f, 0.7347035f),
  float3(-0.0579461f, -0.2569421f, 0.2633952f),
  float3(-0.805769f, -0.09212341f, 0.8110182f),
  float3(-0.8694488f, -0.4897568f, 0.9978993f),
  float3(-0.4935222f, -0.02812241f, 0.4943228f),
  float3(0.1041757f, -0.689613f, 0.6974373f),
  float3(-0.20693f, 0.1556194f, 0.2589158f),
  float3(-0.2454082f, 0.5027568f, 0.5594547f),
  float3(-0.5567301f, 0.4279149f, 0.7021821f),
  float3(-0.9197527f, 0.3381309f, 0.9799376f),
  float3(-0.3161407f, 0.9429287f, 0.9945146f),
  float3(0.3146372f, -0.04715019f, 0.3181504f),
  float3(0.3121662f, -0.4557241f, 0.5523877f),
  float3(-0.2278275f, -0.8239821f, 0.8548987f),
  float3(0.3839736f, -0.8227993f, 0.9079837f),
  float3(0.664671f, -0.7095506f, 0.9722395f),
  float3(0.8773338f, -0.3320521f, 0.9380688f),
  float3(0.6504807f, 0.06075015f, 0.6533114f),
  float3(0.004994333f, 0.7661046f, 0.7661209f),
  float3(0.3393756f, 0.3022597f, 0.4544632f),
  float3(0.3247018f, 0.7385284f, 0.8067561f),
  float3(0.6365398f, 0.440374f, 0.7740234f),
  float3(0.04932644f, 0.3882978f, 0.3914183f),
  float3(0.9752692f, 0.1999909f, 0.9955633f),
  float3(0.03757031f, -0.9852536f, 0.9859697f)
};

const static float3 POISSON_DISC_27[27] = {
  float3(-0.3791736f, 0.8625557f, 0.9422181f),
  float3(0.04697003f, 0.8242583f, 0.8255955f),
  float3(-0.3954813f, 0.3792127f, 0.5479122f),
  float3(-0.7188602f, 0.6515991f, 0.9702275f),
  float3(-0.1867547f, 0.6235506f, 0.6509168f),
  float3(0.3591397f, 0.4949325f, 0.6115059f),
  float3(-0.0306127f, 0.2743996f, 0.2761019f),
  float3(0.1681943f, -0.05980556f, 0.1785106f),
  float3(-0.1693096f, -0.185691f, 0.2512904f),
  float3(-0.423907f, 0.04752547f, 0.4265628f),
  float3(0.5466153f, 0.1456056f, 0.565676f),
  float3(0.9064378f, 0.373319f, 0.9803044f),
  float3(0.612946f, -0.3356552f, 0.6988328f),
  float3(0.8374018f, -0.03730956f, 0.8382325f),
  float3(0.5356598f, 0.7389754f, 0.9126972f),
  float3(-0.8380047f, 0.3023144f, 0.8908681f),
  float3(-0.6073601f, -0.3007822f, 0.6777582f),
  float3(-0.3552741f, -0.4884097f, 0.6039566f),
  float3(-0.8879395f, -0.181777f, 0.906355f),
  float3(0.0263717f, -0.4660244f, 0.4667699f),
  float3(-0.1462954f, -0.7119017f, 0.726778f),
  float3(-0.6778906f, -0.627283f, 0.9235906f),
  float3(0.3023116f, -0.3433301f, 0.457458f),
  float3(0.3212632f, -0.6453792f, 0.7209191f),
  float3(0.01757866f, -0.9690037f, 0.9691631f),
  float3(0.6870059f, -0.7118248f, 0.9892783f),
  float3(-0.458368f, -0.8759024f, 0.988588f)
};

const static float3 POISSON_DISC_30[30] = {
  float3(-0.2356871f, 0.0624318f, 0.2438158f),
  float3(-0.633165f, 0.2267654f, 0.6725478f),
  float3(-0.3978372f, 0.5843436f, 0.7069172f),
  float3(-0.1468216f, -0.3711821f, 0.399165f),
  float3(0.03340992f, -0.138505f, 0.1424776f),
  float3(-0.6227924f, -0.2512115f, 0.6715487f),
  float3(0.1556751f, 0.1937724f, 0.2485608f),
  float3(-0.01955534f, 0.565194f, 0.5655321f),
  float3(0.3498662f, 0.6245103f, 0.7158348f),
  float3(0.5306162f, 0.2818346f, 0.6008197f),
  float3(0.4927936f, -0.03954389f, 0.4943777f),
  float3(0.3059284f, -0.2619868f, 0.4027769f),
  float3(0.2701659f, -0.5412785f, 0.6049562f),
  float3(-0.4429127f, -0.5240915f, 0.6861805f),
  float3(-0.08799095f, -0.9202238f, 0.9244211f),
  float3(-0.9281172f, -0.2732984f, 0.9675192f),
  float3(-0.8136064f, -0.5619215f, 0.9887927f),
  float3(-0.8821444f, 0.01040383f, 0.8822057f),
  float3(-0.7010441f, 0.5750203f, 0.9067035f),
  float3(-0.2749233f, 0.8966907f, 0.9378897f),
  float3(0.7285044f, 0.491388f, 0.8787382f),
  float3(0.9609014f, 0.04839035f, 0.962119f),
  float3(-0.01658046f, -0.6464769f, 0.6466895f),
  float3(-0.387926f, -0.813823f, 0.9015512f),
  float3(0.8148958f, -0.2565637f, 0.8543302f),
  float3(-0.932054f, 0.3055392f, 0.9808562f),
  float3(0.2945456f, -0.8477746f, 0.8974847f),
  float3(0.1106302f, 0.9834179f, 0.989621f),
  float3(0.6243067f, -0.4728437f, 0.7831603f),
  float3(0.5850815f, 0.8033493f, 0.9938262f)
};

const static float3 POISSON_DISC_32[32] = {
  float3(0.8631191f, -0.5041312f, 0.9995614f),
  float3(0.4714256f, -0.5631227f, 0.7344041f),
  float3(0.8253545f, -0.04144434f, 0.8263944f),
  float3(-0.02083254f, -0.7164918f, 0.7167946f),
  float3(0.4826974f, -0.8532528f, 0.980325f),
  float3(0.5150498f, -0.1638356f, 0.5404798f),
  float3(0.1724347f, -0.4785241f, 0.5086443f),
  float3(0.1959768f, -0.1904691f, 0.2732863f),
  float3(0.08431332f, 0.2313876f, 0.2462701f),
  float3(-0.1339047f, -0.1133915f, 0.1754653f),
  float3(-0.2529691f, -0.4776125f, 0.5404693f),
  float3(0.1303819f, -0.9581225f, 0.966953f),
  float3(-0.4313937f, -0.009074868f, 0.4314891f),
  float3(-0.3114846f, 0.3742429f, 0.486909f),
  float3(0.5288804f, 0.4002901f, 0.6632848f),
  float3(0.7909583f, 0.5052915f, 0.9385812f),
  float3(0.5233613f, 0.7598036f, 0.9226096f),
  float3(-0.9246833f, -0.05495682f, 0.9263149f),
  float3(-0.7395077f, -0.4098443f, 0.8454845f),
  float3(-0.5756178f, 0.4759755f, 0.7469193f),
  float3(-0.7304363f, 0.1901211f, 0.7547736f),
  float3(-0.5363522f, -0.6280493f, 0.8259053f),
  float3(-0.2667066f, 0.6752f, 0.7259666f),
  float3(-0.2231799f, -0.9446694f, 0.9706748f),
  float3(-0.8759924f, 0.4388278f, 0.9797614f),
  float3(0.241564f, 0.5031879f, 0.5581678f),
  float3(0.1525959f, 0.8905185f, 0.903498f),
  float3(-0.601495f, 0.7928144f, 0.9951638f),
  float3(0.3798781f, 0.1010495f, 0.3930883f),
  float3(0.9641656f, 0.260849f, 0.9988281f),
  float3(-0.4752097f, -0.2881597f, 0.5557519f),
  float3(-0.1324897f, 0.9670166f, 0.9760505f)
};

const static float3 POISSON_DISC_52[52] = {
  float3(0.7745511f, -0.5852205f, 0.9707792f),
  float3(0.5791471f, -0.3105223f, 0.6571419f),
  float3(0.8490645f, -0.3703334f, 0.9263139f),
  float3(0.5166232f, -0.82269f, 0.9714517f),
  float3(0.5092548f, -0.5285657f, 0.7339769f),
  float3(0.185617f, -0.7601493f, 0.7824836f),
  float3(0.3312583f, -0.3510128f, 0.4826407f),
  float3(0.131391f, -0.07078448f, 0.1492449f),
  float3(0.05573426f, -0.4239672f, 0.4276149f),
  float3(0.498099f, -0.09969237f, 0.5079775f),
  float3(0.8365525f, -0.0870054f, 0.8410648f),
  float3(0.6404527f, 0.06078281f, 0.6433306f),
  float3(-0.01911829f, -0.7996556f, 0.7998841f),
  float3(-0.291609f, -0.3797685f, 0.478811f),
  float3(-0.187265f, -0.1135026f, 0.2189772f),
  float3(-0.2035077f, -0.6631347f, 0.6936591f),
  float3(0.2606209f, 0.2096929f, 0.3345062f),
  float3(0.3011071f, -0.5654439f, 0.6406187f),
  float3(-0.2346171f, -0.9073126f, 0.937156f),
  float3(-0.5188825f, -0.6545654f, 0.8352813f),
  float3(0.7999125f, 0.3004054f, 0.8544608f),
  float3(0.9758008f, 0.07720017f, 0.9788499f),
  float3(0.6669258f, 0.5378156f, 0.8567588f),
  float3(0.4948572f, 0.2349533f, 0.5478017f),
  float3(0.1400821f, -0.9747353f, 0.9847496f),
  float3(0.1223769f, 0.3771746f, 0.3965309f),
  float3(0.370967f, 0.6096475f, 0.7136432f),
  float3(-0.08071592f, 0.1985197f, 0.2143015f),
  float3(-0.02216007f, 0.6019731f, 0.6023809f),
  float3(-0.2404421f, 0.4526593f, 0.5125552f),
  float3(0.3472252f, 0.4060766f, 0.5342879f),
  float3(0.1387725f, 0.7606148f, 0.7731705f),
  float3(-0.6315452f, -0.1922934f, 0.6601713f),
  float3(-0.4171778f, -0.1628922f, 0.4478517f),
  float3(-0.5254954f, -0.4096314f, 0.6662907f),
  float3(-0.01818484f, -0.229769f, 0.2304875f),
  float3(-0.8572523f, 0.084409f, 0.8613979f),
  float3(-0.5660272f, 0.08239014f, 0.571992f),
  float3(-0.9290679f, -0.2388061f, 0.9592682f),
  float3(-0.850853f, -0.5224633f, 0.9984581f),
  float3(0.1745573f, 0.974234f, 0.9897485f),
  float3(0.3924426f, 0.895903f, 0.9780866f),
  float3(-0.1887613f, 0.851751f, 0.8724166f),
  float3(-0.8755164f, 0.3168397f, 0.9310834f),
  float3(-0.4607361f, -0.8838865f, 0.9967613f),
  float3(-0.2813884f, 0.07622426f, 0.2915297f),
  float3(-0.5995572f, 0.4540546f, 0.7520867f),
  float3(-0.4433854f, 0.2606268f, 0.5143121f),
  float3(-0.4497591f, 0.6271001f, 0.7717109f),
  float3(-0.5144858f, 0.8326961f, 0.9788148f),
  float3(-0.7890354f, 0.581238f, 0.9800074f),
  float3(0.622973f, 0.7507558f, 0.9755663f)
};

const static float3 POISSON_DISC_64[64] = {
  float3(-0.4701085f, -0.7088585f, 0.8505777f),
  float3(-0.588863f, -0.4344515f, 0.7317839f),
  float3(-0.2637807f, -0.4638988f, 0.53365f),
  float3(-0.6705907f, -0.6723164f, 0.9495795f),
  float3(-0.1595647f, -0.7843025f, 0.8003694f),
  float3(-0.3630824f, -0.8779938f, 0.9501063f),
  float3(-0.009135416f, -0.9246601f, 0.9247052f),
  float3(-0.8220799f, -0.5655432f, 0.9978248f),
  float3(-0.4049134f, -0.235123f, 0.4682282f),
  float3(-0.7447825f, -0.2819431f, 0.7963623f),
  float3(-0.01387333f, -0.5906205f, 0.5907834f),
  float3(-0.1114751f, -0.3115323f, 0.3308762f),
  float3(-0.3014135f, -0.6454485f, 0.712358f),
  float3(-0.1992328f, -0.9684969f, 0.988777f),
  float3(-0.2538784f, -0.1210603f, 0.2812647f),
  float3(-0.6354901f, -0.08802678f, 0.6415578f),
  float3(-0.4777399f, 0.005563241f, 0.4777723f),
  float3(-0.8284558f, -0.04062854f, 0.8294514f),
  float3(-0.9363952f, -0.3109031f, 0.9866594f),
  float3(0.2723194f, -0.5570934f, 0.6200894f),
  float3(0.1297426f, -0.7478408f, 0.7590118f),
  float3(0.1239235f, -0.4495131f, 0.4662822f),
  float3(-0.202408f, 0.1138636f, 0.2322367f),
  float3(-0.6388171f, 0.1740293f, 0.6620978f),
  float3(-0.4049088f, 0.3235209f, 0.5182827f),
  float3(-0.3346956f, 0.6114994f, 0.6971031f),
  float3(-0.1264489f, 0.4095905f, 0.4286651f),
  float3(-0.5748344f, 0.5884711f, 0.8226377f),
  float3(0.02929708f, -0.1079792f, 0.1118831f),
  float3(0.2199977f, -0.1773379f, 0.2825734f),
  float3(0.1352276f, 0.1025547f, 0.1697174f),
  float3(0.08131796f, 0.2997207f, 0.3105562f),
  float3(0.4476834f, -0.2911924f, 0.5340537f),
  float3(0.4488126f, -0.7780288f, 0.8981991f),
  float3(0.4545987f, -0.5887712f, 0.7438492f),
  float3(0.6908568f, -0.5091766f, 0.8582214f),
  float3(0.2688767f, -0.871239f, 0.9117851f),
  float3(-0.8278108f, 0.1597875f, 0.8430912f),
  float3(-0.8018228f, 0.4058242f, 0.8986729f),
  float3(-0.597547f, 0.3507269f, 0.6928721f),
  float3(-0.0608962f, 0.6406011f, 0.643489f),
  float3(-0.4738878f, 0.7382848f, 0.8772879f),
  float3(-0.1935091f, 0.8549305f, 0.8765568f),
  float3(0.2452414f, 0.4845924f, 0.5431144f),
  float3(0.4281014f, 0.259131f, 0.5004195f),
  float3(0.4120286f, -0.0158269f, 0.4123325f),
  float3(0.6430962f, 0.3437865f, 0.7292201f),
  float3(0.7154608f, 0.07864784f, 0.7197706f),
  float3(-0.7621346f, 0.5912436f, 0.9645818f),
  float3(0.7429131f, -0.2366951f, 0.7797078f),
  float3(0.8604265f, 0.1888512f, 0.8809078f),
  float3(0.9054561f, -0.007376944f, 0.9054861f),
  float3(0.9449676f, -0.2495391f, 0.9773604f),
  float3(0.0467854f, 0.9970599f, 0.998157f),
  float3(0.8492389f, 0.3866454f, 0.9331139f),
  float3(0.4655244f, 0.5951079f, 0.7555571f),
  float3(0.7018923f, 0.5815012f, 0.9114803f),
  float3(0.2217146f, 0.7051865f, 0.7392195f),
  float3(0.4141883f, 0.8879948f, 0.9798401f),
  float3(0.05556146f, 0.7979619f, 0.7998939f),
  float3(0.5932183f, 0.7998808f, 0.99585f),
  float3(0.2294766f, 0.9267679f, 0.9547556f),
  float3(0.8889188f, -0.4246621f, 0.985147f),
  float3(0.6040397f, -0.1214489f, 0.616128f)
};

const static float3 POISSON_DISC_96[96] = {
  float3(-0.13087f, 0.1202948f, 0.1777577f),
  float3(-0.05284534f, 0.3067739f, 0.3112922f),
  float3(-0.333617f, 0.3109172f, 0.4560371f),
  float3(0.02221257f, 0.05802792f, 0.06213403f),
  float3(-0.03752725f, -0.1457734f, 0.1505264f),
  float3(0.07318151f, 0.2163823f, 0.2284224f),
  float3(-0.2859612f, 0.09503992f, 0.301341f),
  float3(-0.2511355f, -0.1262494f, 0.2810836f),
  float3(-0.4722719f, 0.4577924f, 0.6577345f),
  float3(-0.4772194f, 0.192394f, 0.5145423f),
  float3(-0.2908138f, 0.5457753f, 0.6184201f),
  float3(-0.6053115f, 0.3796158f, 0.7145f),
  float3(-0.1864402f, 0.3866558f, 0.4292582f),
  float3(0.1263114f, -0.1085021f, 0.1665151f),
  float3(0.2148282f, 0.2757809f, 0.3495801f),
  float3(0.3061649f, 0.007086046f, 0.3062468f),
  float3(-0.493231f, 0.7328417f, 0.883365f),
  float3(-0.3363303f, 0.7649355f, 0.8356102f),
  float3(-0.1813799f, 0.8000156f, 0.8203192f),
  float3(-0.06473596f, 0.5502034f, 0.5539986f),
  float3(-0.0592885f, 0.7032489f, 0.7057437f),
  float3(-0.4927787f, -0.02079139f, 0.4932171f),
  float3(-0.4070357f, -0.1642561f, 0.4389284f),
  float3(0.1665222f, 0.4600125f, 0.489225f),
  float3(-0.744941f, 0.5808949f, 0.9446566f),
  float3(0.354789f, 0.1895004f, 0.4022259f),
  float3(0.199279f, 0.1150851f, 0.2301232f),
  float3(-0.7241346f, 0.03105169f, 0.7248001f),
  float3(-0.6222042f, -0.1044065f, 0.6309032f),
  float3(-0.7644989f, 0.2000756f, 0.790246f),
  float3(0.06226893f, 0.8496996f, 0.8519782f),
  float3(0.2249717f, 0.6426599f, 0.6808994f),
  float3(0.07291475f, 0.6206694f, 0.6249376f),
  float3(-0.818464f, -0.2288188f, 0.8498479f),
  float3(-0.570171f, -0.2897124f, 0.6395532f),
  float3(-0.881316f, -0.04806949f, 0.8826259f),
  float3(-0.9102924f, 0.1114485f, 0.9170894f),
  float3(-0.8719838f, 0.3188506f, 0.9284511f),
  float3(0.2682715f, 0.825101f, 0.8676181f),
  float3(-0.196363f, 0.9750041f, 0.994581f),
  float3(-0.01672673f, 0.9869143f, 0.987056f),
  float3(-0.7376396f, -0.3668682f, 0.8238352f),
  float3(-0.3938256f, -0.3345885f, 0.516767f),
  float3(0.4449012f, 0.5086449f, 0.6757638f),
  float3(-0.1463907f, -0.2752427f, 0.3117512f),
  float3(-0.3466873f, 0.915874f, 0.9792942f),
  float3(-0.6427018f, 0.7645023f, 0.998764f),
  float3(-0.4501481f, -0.567009f, 0.72397f),
  float3(-0.1330234f, -0.4425981f, 0.4621561f),
  float3(-0.5900673f, 0.5697352f, 0.8202302f),
  float3(-0.6173884f, -0.4882373f, 0.7871113f),
  float3(-0.6651976f, -0.6492043f, 0.9294913f),
  float3(-0.5035031f, -0.747659f, 0.901393f),
  float3(-0.8618331f, -0.5043709f, 0.9985721f),
  float3(0.4764097f, -0.05734111f, 0.4798481f),
  float3(0.5390552f, 0.2753316f, 0.6052999f),
  float3(0.5136539f, 0.1111689f, 0.5255462f),
  float3(0.4000847f, 0.3417251f, 0.5261595f),
  float3(0.2000137f, -0.3510709f, 0.4040498f),
  float3(0.053367f, -0.3862247f, 0.3898943f),
  float3(0.3160075f, -0.1778904f, 0.3626372f),
  float3(0.4685009f, 0.7388906f, 0.8749014f),
  float3(0.6157863f, 0.5436366f, 0.8214216f),
  float3(0.6912873f, 0.6769604f, 0.9675503f),
  float3(0.44682f, -0.2736302f, 0.523948f),
  float3(0.347224f, -0.3868017f, 0.5197884f),
  float3(0.7800358f, 0.3769791f, 0.8663539f),
  float3(0.8263464f, 0.531272f, 0.9823942f),
  float3(0.09672353f, -0.6111912f, 0.6187973f),
  float3(0.2589567f, -0.578692f, 0.6339898f),
  float3(0.7463101f, 0.06608922f, 0.7492306f),
  float3(0.7599738f, -0.1299787f, 0.7710088f),
  float3(0.6244305f, -0.2298666f, 0.6653962f),
  float3(0.9009126f, 0.2684513f, 0.9400584f),
  float3(0.6233798f, -0.3916594f, 0.7362061f),
  float3(0.4870341f, -0.5296404f, 0.7195284f),
  float3(-0.202003f, -0.624809f, 0.6566517f),
  float3(-0.3735959f, -0.8559637f, 0.933942f),
  float3(-0.2339533f, -0.9196866f, 0.9489772f),
  float3(-0.1156498f, -0.8093094f, 0.8175308f),
  float3(0.4280396f, -0.7693508f, 0.8804081f),
  float3(0.06415144f, -0.8029392f, 0.8054979f),
  float3(0.6496861f, -0.5803798f, 0.8711674f),
  float3(0.3184004f, -0.9107345f, 0.9647882f),
  float3(0.6593018f, -0.7353091f, 0.9876024f),
  float3(-0.3067569f, -0.5063242f, 0.592f),
  float3(0.8940688f, -0.3869704f, 0.9742202f),
  float3(0.8747854f, -0.2324821f, 0.9051505f),
  float3(0.7999458f, -0.5932202f, 0.9959034f),
  float3(0.0603983f, -0.9672006f, 0.9690846f),
  float3(0.9125931f, 0.0556354f, 0.9142874f),
  float3(-0.8692296f, 0.4743353f, 0.9902293f),
  float3(0.6358393f, -0.03861726f, 0.6370109f),
  float3(0.9767168f, -0.1069829f, 0.9825584f),
  float3(0.2309739f, -0.7827856f, 0.8161509f),
  float3(-0.04528206f, -0.6618667f, 0.6634139f)
};

#define SAMPLE_POISSON(SIZE, INDEX) POISSON_DISC_##SIZE[INDEX].xy
#define SAMPLE_POISSON_LENGTH(SIZE, INDEX) POISSON_DISC_##SIZE[INDEX].z

#define POISSON_AVG(VAR_TYPE, VAR_NAME, TEX, SAMPLER, UV, RADIUS, NUM)\
  VAR_TYPE VAR_NAME = 0; {\
  float2 _uv = UV; float _radius = RADIUS;\
  for (uint i = 0; i < NUM; ++i) {\
    float2 dir = SAMPLE_POISSON(NUM, i);\
    VAR_NAME += TEX.SampleLevel(SAMPLER, _uv + dir * _radius, 0);\
  }\
  VAR_NAME /= NUM; }

#define POISSON_AVG_LEVEL(VAR_TYPE, VAR_NAME, TEX, SAMPLER, UV, RADIUS, NUM, LEVEL)\
  VAR_TYPE VAR_NAME = 0; {\
  float2 _uv = UV; float _radius = RADIUS;\
  for (uint i = 0; i < NUM; ++i) {\
    float2 dir = SAMPLE_POISSON(NUM, i);\
    VAR_NAME += TEX.SampleLevel(SAMPLER, _uv + dir * _radius, LEVEL);\
  }\
  VAR_NAME /= NUM; }

#endif